import org.junit.Test;

import java.awt.*;
import java.util.HashMap;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

public class MazeTest {

    @Test
    public void testMakeMaze()  {
        Maze maze = new Maze("testmaze.txt");
        maze.createMazeGraph();
        HashMap<Point, Maze.MazeNode> nodes = maze.getNodes();
        Maze.MazeNode node1 = nodes.get(new Point(0, 1));
        Maze.MazeNode node2 = nodes.get(new Point(1, 1));
        Maze.MazeNode node3 = nodes.get(new Point(1, 2));
        assertTrue(node1.adjacencyList.contains(node2));
        assertTrue(node2.adjacencyList.contains(node1));
        assertEquals(2, node2.adjacencyList.size());
        assertEquals(3, node3.adjacencyList.size());
    }

    @Test
    public void testMakeMazeLarge()  {
        Maze maze = new Maze("testmaze2.txt");
        maze.createMazeGraph();
        HashMap<Point, Maze.MazeNode> nodes = maze.getNodes();
        Maze.MazeNode node1 = nodes.get(new Point(3, 7));
        Maze.MazeNode node2 = nodes.get(new Point(3, 6));
        assertTrue(node1.adjacencyList.contains(node2));
        assertTrue(node2.adjacencyList.contains(node1));
        assertEquals(4, node1.adjacencyList.size());
    }

    @Test
    public void testBFS(){
        Point startingCoords = new Point(1, 2);
        Maze maze = new Maze("testmaze.txt");
        maze.createMazeGraph();
        assertEquals(new Point(2,2), maze.findNearestExit(startingCoords).coords);

        Point startingCoords2 = new Point(5, 5);
        Maze maze2 = new Maze("testmaze2.txt");
        maze2.createMazeGraph();
        assertEquals(new Point(1,0), maze2.findNearestExit(startingCoords2).coords);
    }
}